#include <minigui.ch>

Function Main
local aData := {}
  
aData := initdata()  
define window s at 0,0 width 1024 height 768 title "Xtract Sample" main 
   define grid data
      row 10
      col 10
      width 1000
      height 600
      items aData
      headers {"REGION","PRODUCT","SALESMAN","QUANTITY","DISCOUNT"}
      widths {150,150,150,150,150}
      justify {0,0,0,1,1}
   	COLUMNCONTROLS { {'TEXTBOX','CHARACTER'} , {'TEXTBOX','CHARACTER'} ,{'TEXTBOX','CHARACTER'},{'TEXTBOX','NUMERIC','999999'}  , {'TEXTBOX','NUMERIC','99'}} 
   end grid
   define button xtract
      row 620
      col 10
      width 80
      caption "Xtract"
      action dataxtract("s","data")
   end button
   define button csvexport
      row 620
      col 110
      width 80
      caption "Xport2CSV"
      action grid2csv("s","data",.t.)
   end button
   define button import
      row 620
      col 210
      width 80
      caption "DBF Import"
      action importfromdbf()
   end button
   define button close
      row 620
      col 310
      width 80
      caption "Close"
      action s.release()
   end button
end window
s.center
s.activate


Return

function dataxtract(cWindow,cGrid)
local aTypes := {}
local nItemCount := 0
local aLineData := {}
local i := nil
local aEditControls := {}
local aJustify := {}
private cWindowName := cWindow
private cGridName := cGrid
private aOperations := {"SUM","MINIMUM","MAXIMUM","COUNT"}
private aCols := {}



nItemCount := getproperty(cWindow,cGrid,"itemcount")
if nItemCount == 0
   return nil
endif
aLineData := getproperty(cWindow,cGrid,"item",1)
for nCount := 1 to len(aLineData)
   aadd(aCols,getproperty(cWindow,cGrid,"header",nCount))
   aadd(aTypes,valtype(aLineData[nCount]))
next nCount
i := GetControlIndex ( cGrid , cWindow )
aJustify := _HMG_SYSDATA [ 37 ] [i]
   
define window xtract at 0,0 width 530 height 630 title "Xtract Window" modal 
   define label available
      row 10
      col 10
      width 200
      value "Available Columns"
   end label
   define listbox cols
      row 40
      col 10
      width 200
      height 150
      items aCols
      value 1
   end listbox
   define button addrow
      row 40
      col 220
      width 40
      caption "Row"
      fontbold .t.
      action addrow()
   end button
   define button addcol
      row 70
      col 220
      width 40
      fontbold .t.
      caption "Col"
      action addcol()
   end button
   define button adddata
      row 100
      col 220
      width 40
      fontbold .t.
      caption "Data"
      action adddata()
   end button
   define label operationslabel
      row 10
      col 270
      width 150
      value "Data Grouping Operations"
   end label
   define listbox operations
      row 40
      col 270
      width 150
      items aOperations
      value 1
      height 150
   end listbox
   define label selectedrowslabel
      row 200
      col 10
      width 200
      value "Row Grouping"
   end label
   define listbox selrows
      row 230
      col 10
      width 200
      height 150
   end listbox
   define button delrow
      row 230
      col 220
      width 40
      fontsize 30
      fontbold .t.
      caption "Del"
      action removerow()
   end button
   define label selectedcolslabel
      row 200
      col 270
      width 200
      value "Column Grouping"
   end label
   define listbox selcols
      row 230
      col 270
      width 200
      height 150
   end listbox
   define button delcol
      row 230
      col 480
      width 40
      fontsize 30
      fontbold .t.
      caption "Del"
      action removecol()
   end button
   define label datalabel
      row 410
      col 10
      width 200
      value "Selected Data & Operations"
   end label
   define grid datacols
      row 440
      col 10
      width 350
      headers {"Data","Operation"}
      widths {200,120}
      height 100
   end grid
   define button removedata
      row 440
      col 370
      width 40
      caption "Del"
      fontsize 30
      fontbold .t.
      action removedata()
   end button   
   define button report
      row 550
      col 10
      width 80
      caption "Report"
      action createreport()
   end button
   define button close
      row 550
      col 110
      width 80
      caption "Close"
      action xtract.release()
   end button
   define progressbar p1
      row 550
      col 210
      width 300
      rangemin 0
      rangemax 100
      value 0
   end progressbar
   define statusbar
      statusitem "Welcome"
   end statusbar
end window
xtract.p1.visible := .f.
xtract.center
xtract.activate

return nil

function addrow
local nValue := xtract.cols.value
if nValue > 0
   xtract.selrows.additem(xtract.cols.item(nValue))
   xtract.selrows.value := xtract.selrows.itemcount
   xtract.cols.deleteitem(nValue)
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function addcol
local nValue := xtract.cols.value
if nValue > 0
   xtract.selcols.additem(xtract.cols.item(nValue))
   xtract.selcols.value := xtract.selcols.itemcount
   xtract.cols.deleteitem(nValue)
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function removerow
local aOld := {}
local aNew := {}
local i := 0
local nValue := xtract.selrows.value
if nValue > 0
   for i := 1 to xtract.cols.itemcount
      aadd(aOld,xtract.cols.item(i))
   next i
   aadd(aOld,xtract.selrows.item(nValue))
   for i := 1 to len(aCols)
      if ascan(aOld,aCols[i]) > 0
         aadd(aNew,aCols[i])
      endif
   next i
   xtract.selrows.deleteitem(nValue)
   if xtract.selrows.itemcount > 0
      xtract.selrows.value := 1
   endif
   xtract.cols.deleteallitems()
   for i := 1 to len(aNew)
      xtract.cols.additem(aNew[i])
   next i
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function removecol
local aOld := {}
local aNew := {}
local i := 0
local nValue := xtract.selcols.value
if nValue > 0
   for i := 1 to xtract.cols.itemcount
      aadd(aOld,xtract.cols.item(i))
   next i
   aadd(aOld,xtract.selcols.item(nValue))
   for i := 1 to len(aCols)
      if ascan(aOld,aCols[i]) > 0
         aadd(aNew,aCols[i])
      endif
   next i
   xtract.selcols.deleteitem(nValue)
   if xtract.selcols.itemcount > 0
      xtract.selcols.value := 1
   endif
   xtract.cols.deleteallitems()
   for i := 1 to len(aNew)
      xtract.cols.additem(aNew[i])
   next i
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif

return nil

function adddata
local nValue := xtract.cols.value
local nOpValue := xtract.operations.value
if nValue > 0 .and. nOpValue > 0
   xtract.datacols.additem({xtract.cols.item(nValue),xtract.operations.item(nOpValue)})
   xtract.datacols.value := xtract.datacols.itemcount
   xtract.cols.deleteitem(nValue)
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function removedata
local aOld := {}
local aNew := {}
local i := 0
local nValue := xtract.datacols.value
local aLineData := {}
if nValue > 0
   for i := 1 to xtract.cols.itemcount
      aadd(aOld,xtract.cols.item(i))
   next i
   aLinedata := xtract.datacols.item(nValue)
   aadd(aOld,aLineData[1])
   for i := 1 to len(aCols)
      if ascan(aOld,aCols[i]) > 0
         aadd(aNew,aCols[i])
      endif
   next i
   xtract.datacols.deleteitem(nValue)
   if xtract.datacols.itemcount > 0
      xtract.datacols.value := 1
   endif
   xtract.cols.deleteallitems()
   for i := 1 to len(aNew)
      xtract.cols.additem(aNew[i])
   next i
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif

return nil

function createreport
local aRowIds := {}
local aColIds := {}
local aDataIds := {}
local aLineData := {}
local aRowData := {}
local aColData := {}
local aData := {}
local aCurRows := {}
local aCurCols := {}
local aCurRow := {}
local aReportData := {}
local aReportCols := {}
local aReportRows := {}
local aIsCols := {}
local aIsRows := []
local aReportRowsTranspose := {}
local aReportData1 := {}
local aRowDataSorted := {}
local aColDataSorted := {}

if xtract.selrows.itemcount > 0 .and. xtract.selcols.itemcount > 0 .and. xtract.datacols.itemcount == 0
   msgstop("You have to select a Data field if you select both Row and Col!")
   return nil
endif

if xtract.selrows.itemcount == 0 .and. xtract.selcols.itemcount == 0 .and. xtract.datacols.itemcount == 0
   msgstop("You have to select atleast a Row/Col Field and/or a Data Field!")
   return nil
endif

xtract.statusbar.item(1) := "Classifying & Summarising..."

for i := 1 to xtract.selrows.itemcount
   aadd(aRowIds,ascan(aCols,xtract.selrows.item(i)))
next i

for i := 1 to xtract.selcols.itemcount
   aadd(aColIds,ascan(aCols,xtract.selcols.item(i)))
next i

for i := 1 to xtract.datacols.itemcount
   aLineData := xtract.datacols.item(i)
   aadd(aDataIds,{ascan(aCols,aLineData[1]),ascan(aOperations,aLineData[2])})
next i

nItemCount := getproperty(cWindowName,cGridName,"itemcount")

for i := 1 to len(aRowIds)
   aadd(aRowData,{})
next i

for i := 1 to len(aColIds)
   aadd(aColData,{})
next i

xtract.p1.visible := .t.
for i := 1 to nItemCount
   xtract.p1.value := (i/nItemCount) * 100
   aLineData := getproperty(cWindowName,cGridName,"item",i)
   nRows := len(aRowIds)
   asize(aCurRows,0)
   asize(aCurcols,0)
   for j := 1 to nRows
      xRowData := aLineData[aRowIds[j]]
      nPos := ascan(aRowData[j],xRowData)
      if nPos == 0
         aadd(aRowData[j],xRowData)
      endif
      aadd(aCurRows,ascan(aRowData[j],xRowData))
   next j
   
   nCols := len(aColIds)
   for j := 1 to nCols
      xColData := aLinedata[aColIds[j]]
      nPos := ascan(aColData[j],xColData)
      if nPos == 0
         aadd(aColData[j],xColData)
      endif
      aadd(aCurCols,ascan(aColData[j],xColData))
   next j
   
   nDataIds := len(aDataIds)
   for j := 1 to nDataIds
      xRowData := aLineData[aDataIds[j,1]]
      nOperation := aDataIds[j,2]
      nPos := 0
      nPos := ascan(aData,{|x| comparearrays(x[1],aCurRows) .and. comparearrays(x[2],aCurCols) .and. x[3] == j})
      if nPos == 0
         if nOperation == 2 .or. nOperation == 3 // minimum or maximum initialisation
            aadd(aData,{aclone(aCurRows),aclone(aCurCols),j,xRowData})
         else
            aadd(aData,{aclone(aCurRows),aclone(aCurCols),j,0})
         endif   
         nPos := len(aData)
      endif
      do case
         case nOperation == 1 // Sum
            do case
               case valtype(xRowData) == "C"
                  aData[nPos,4] := aData[nPos,4] + val(alltrim(xRowData))
               case valtype(xRowData) == "N"
                  aData[nPos,4] := aData[nPos,4] + xRowData
               otherwise
                  aData[nPos,4] := 0.0
            endcase                  
         case nOperation == 2 // Minimum
            do case
               case valtype(xRowData) == "C"
                  aData[nPos,4] := min(aData[nPos,4],val(alltrim(xRowData)))
               case valtype(xRowData) == "N"
                  aData[nPos,4] := min(aData[nPos,4],xRowData)
               otherwise
                  aData[nPos,4] := 0.0
            endcase      
         case nOperation == 3 // Maximum
            do case
               case valtype(xRowData) == "C"
                  aData[nPos,4] := max(aData[nPos,4],val(alltrim(xRowData)))
               case valtype(xRowData) == "N"
                  aData[nPos,4] := max(aData[nPos,4],xRowData)
               otherwise
                  aData[nPos,4] := 0.0
            endcase      
         case nOperation == 4 // Count
            aData[nPos,4] := aData[nPos,4] + 1
      endcase
   next j
next i

// sorting
xtract.statusbar.item(1) := "Sorting & Preparing the Report..."

for i := 1 to len(aRowData)
   aLineData := aRowData[i]
   aadd(aRowDataSorted,asort(aclone(aLineData)))
next i

for i := 1 to len(aColData)
   aLineData := aColData[i]
   aadd(aColDataSorted,asort(aclone(aLineData)))
next i



for i := 1 to len(aData)
   aLineData := aData[i,1]  //Row co-ordinates
   for j := 1 to len(aLineData)
      nOldRow := aLineData[j]
      nNewRow := ascan(aRowDataSorted[j],{|x| x == aRowData[j,nOldRow]})
      aLineData[j] := nNewRow
   next j
   aData[i,1] := aclone(aLineData)
next i

for i := 1 to len(aData)
   aLineData := aData[i,2]  //Col co-ordinates
   for j := 1 to len(aLineData)
      nOldCol := aLineData[j]
      nNewCol := ascan(aColDataSorted[j],{|x| x == aColData[j,nOldCol]})
      aLineData[j] := nNewCol
   next j
   aData[i,2] := aclone(aLineData)
next i
aRowData := aclone(aRowDataSorted)
aColData := aclone(aColDataSorted)

// row,col determination
nTotRows := 1
nTotCols := 1
for i := 1 to len(aRowData)
   nTotRows := nTotRows * len(aRowData[i])
next i
for i := 1 to len(aColData)
   nTotCols := nTotCols * len(aColData[i])
next i
nTotRows := nTotRows * len(aDataIds)
nRow := 1
nCol := 1
for i := 1 to len(aData)

   aLineData := aData[i,1] // Row Co-ordinates
   nRow := 0
   for j := 1 to len(aLineData)
      nTemp := 1
      nTemp := nTemp * aLineData[j] - 1
      for k := j+1 to len(aRowData)
         nTemp := nTemp * len(aRowData[k])
      next k
      nTemp := nTemp * len(aDataIds)
      nRow := nRow + nTemp
   next j
   nRow := nRow + aData[i,3]

   aLineData := aData[i,2] // col co-ordinates
   nCol := 0
   for j := 1 to len(aLineData)
      nTemp := 1
      nTemp := nTemp * aLineData[j] - 1
      for k := j+1 to len(aColData)
         nTemp := nTemp * len(aColData[k])
      next k
      nCol := nCol + nTemp
   next j
   nCol := nCol + 1 
   aadd(aReportData,{nRow,nCol,aData[i,4]})
next i   

aIsCols := {}
aIsRows := {}

for i := 1 to nTotRows
   if ascan(aReportData,{|x|x[1] == i}) > 0
      aadd(aIsRows,.t.)
   else
      aadd(aIsRows,.f.)
   endif
next i

for i := 1 to nTotCols
   if ascan(aReportData,{|x|x[2] == i}) > 0
      aadd(aIsCols,.t.)
   else
      aadd(aIsCols,.f.)
   endif
next i





//column headers
aReportCols := {}
nCurColCount := 1
nCurCol := 0
for i := 1 to len(aColData)
   asize(aCurRow,0)
   aLineData := aColData[i]
   nTimes := nCurColCount
   nCurColCount := nCurColCount * len(aLineData)
   nSkip := (nTotCols/nCurColCount) - 1
   for j := 1 to nTimes
      for k := 1 to len(aLineData)
         aadd(aCurRow,aLineData[k])
         for l := 1 to nSkip
            nCurCol := nCurCol + 1
            aadd(aCurRow,'')
         next l
      next k
   next j   
   aadd(aReportCols, aclone(aCurRow))
next i


//Row headers
aReportRows := {}
nCurRowCount := 1
nCurRow := 0

nTotRows1 := 1
for i := 1 to len(aRowData)
   nTotRows1 := nTotRows1 * len(aRowData[i])
next i

for i := 1 to len(aRowData)
   asize(aCurRow,0)
   aLineData := aRowData[i]
   nTimes := nCurRowCount
   nCurRowCount := nCurRowCount * len(aLineData)
   nSkip := (nTotRows1/nCurRowCount) - 1
   for j := 1 to nTimes
      for k := 1 to len(aLineData)
         aadd(aCurRow,aLineData[k])
         for l := 1 to nSkip
            nCurRow := nCurRow + 1
            aadd(aCurRow,'')
         next l
      next k
   next j   
   aadd(aReportRows, aclone(aCurRow))
next i

nRows := len(aReportRows)
if nRows > 0
   nCols := len(aReportRows[1])
   aReportRowsTranspose := array(nCols,nRows)
   for i := 1 to nRows
      for j := 1 to nCols
         aReportRowsTranspose[j,i] := aReportRows[i,j]
      next j
   next i
   aReportRows := aclone(aReportRowsTranspose)
endif




aReportGrid := {}
aCurRow := {}
for i := 1 to len(aRowData)
   aadd(aCurRow,xtract.selrows.item(i))
next i
if xtract.datacols.itemcount > 1
   aadd(aCurRow,"Data")
endif
if len(aReportCols) > 0
   aLineData := aReportCols[1]
   for i := 1 to len(aLineData)
      aadd(aCurRow,aLineData[i])
   next i
else
   if xtract.datacols.itemcount > 0
      aadd(aCurRow,'') // data   
   endif      
endif
aadd(aReportGrid,aclone(aCurRow))
asize(aCurRow,0)
for i := 2 to len(aReportCols)
   for j := 1 to len(aRowData)
      aadd(aCurRow,'')
   next j
   if xtract.datacols.itemcount > 1
      aadd(aCurRow,'')
   endif
   aLineData := aReportCols[i]
   for j := 1 to len(aLineData)
      aadd(aCurRow,aLineData[j])
   next j
   aadd(aReportGrid,aclone(aCurRow))
   asize(aCurRow,0)
next i


aReportData1 := array(nTotRows,nTotCols)
for i := 1 to nTotRows
   for j := 1 to nTotCols
      aReportData1[i,j] := ''
   next j
next i

for i := 1 to len(aReportData)
   aLineData := aReportData[i]
   for j := 1 to len(aLineData)
      aReportData1[aLineData[1],aLineData[2]] := str(aLineData[3])
   next j
next i   

nCurRow := 1
if len(aReportRows) > 0
   for i := 1 to len(aReportRows)
      asize(aCurRow,0)
      if xtract.datacols.itemcount > 1
         for j := 1 to xtract.datacols.itemcount
            if j == 1
               aLineData := aReportRows[i]
               for k := 1 to len(aLineData)
                  aadd(aCurRow,aLineData[k])
               next k
               aLineData := xtract.datacols.item(j)   
               aadd(aCurRow,alltrim(aLineData[2])+"-"+alltrim(aLineData[1]))
            else
               aLineData := aReportRows[i]
               for k := 1 to len(aLineData)
                  aadd(aCurRow,'')
               next k
               aLineData := xtract.datacols.item(j)   
               aadd(aCurRow,alltrim(aLineData[2])+"-"+alltrim(aLineData[1]))
            endif
            for k := 1 to nTotCols
               aadd(aCurRow,aReportData1[nCurRow,k])
            next k
            aadd(aReportGrid,aclone(aCurRow))
            nCurRow := nCurRow + 1
            asize(aCurRow,0)               
         next j
      else
         aLineData := aReportRows[i]
         for j := 1 to len(aLineData)
            aadd(aCurRow,aLineData[j])
         next j
         if len(aReportData1) > 0
            for j := 1 to nTotCols
               aadd(aCurRow,aReportData1[i,j])
            next j
         endif   
         aadd(aReportGrid,aclone(aCurRow))
      endif
   next i
else
   if xtract.datacols.itemcount > 0
      if xtract.datacols.itemcount > 1
         for k := 1 to xtract.datacols.itemcount
            aLineData := xtract.datacols.item(k)
            asize(aCurRow,0)
            aadd(aCurRow,alltrim(aLineData[2])+"-"+alltrim(aLineData[1]))
            for j := 1 to nTotCols
               aadd(aCurRow,aReportData1[k,j])
            next j
            aadd(aReportGrid,aclone(aCurRow))
         next k
      else
         asize(aCurRow,0)
         for i := 1 to len(aReportData1)
            for j := 1 to nTotCols
               aadd(aCurRow,aReportData1[i,j])
            next j
         next i
         aadd(aReportGrid,aclone(aCurRow))
      endif
   endif
endif


if len(aData) > 0
   // empty row elimination

   nCount := len(aRowData)
   if xtract.datacols.itemcount > 1
      nCount := nCount + 1
   endif
   nStart := len(aReportGrid)-len(aIsRows)
   for i := 1 to len(aIsRows)
      if .not. aIsRows[i]
         aLineData := aReportGrid[nstart+i]
         if nstart+i < len(aReportGrid)
            for j := 1 to nCount
               if len(alltrim(aLineData[j])) > 0
                  if len(alltrim(aReportGrid[nstart+i+1,j])) == 0
                        aReportGrid[nstart+i+1,j] := aLineData[j]
                  endif
               endif
            next j
         endif
      endif
   next i
   for i := len(aReportGrid) to nStart+1 step -1
      if .not. aIsRows[i-nStart]
         adel(aReportGrid,i)
         asize(aReportGrid,len(aReportGrid)-1)
      endif
   next i
   
   
   // empty col elimination
   
   
   nCount := len(aColData)
   nEnd := len(aReportGrid)-len(aIsRows)
   nStart := len(aRowData)+iif(xtract.datacols.itemcount > 1,1,0)
   if len(aReportGrid) > 0
      nEndCol := len(aReportGrid[1])
   else
      nEndCol := 0
   endif
   for i := 1 to len(aIsCols)
      if .not. aIsCols[i]
         if i < len(aIsCols)
            for k := 1 to nEnd
               if len(alltrim(aReportGrid[k,nStart+i])) > 0 .and. len(alltrim(aReportGrid[k,nStart+i+1])) == 0
                  aReportGrid[k,nStart+i+1] := aReportGrid[k,nStart+i]
               endif
            next k   
         endif   
      endif   
   next i
   for j := len(aIsCols) to 1 step -1
      if .not. aIsCols[j]
         for i := 1 to len(aReportGrid)
            if len(aReportGrid[i]) >= nStart+j
               adel(aReportGrid[i,nStart+j])
               asize(aReportGrid[i],len(aReportGrid[i])-1)
            endif   
         next i
      endif   
   next i
endif

xtract.p1.visible := .f.
xtract.statusbar.item(1) := "Finished"


if len(aReportGrid) > 0
   aHeaders := {}
   aWidths := {}
   aJustify := {}
   for i := 1  to len(aReportGrid[1])
      aadd(aHeaders,'')
      aadd(aWidths,100)
      if i > 1 .and. i > len(aRowData)+iif(xtract.datacols.itemcount > 1,1,0)
         aadd(aJustify,1)
      else
         aadd(aJustify,0)
      endif   
   next i

   define window xtractreport at 0,0 width 1000 height 600 title "Xtract Report" modal nosize nosysmenu
      define grid data
         row 10
         col 10
         width 980
         height 500
         widths aWidths
         headers aHeaders
         justify aJustify
         showheaders .f.
         items aReportGrid
      end grid
         
      define button close
         row 520
         col 10
         width 80
         caption "Close"
         action xtractreport.release()
      end button
   end window
   xtractreport.center
   xtractreport.activate

endif

return nil






function comparearrays(x,y)
local i,j := 0
local lenx,leny := 0
local xelement, yelement
if valtype(x) == "A" .and. valtype(y) == "A"
   lenx := len(x)
   leny := len(y)
   if lenx <> leny
      return .f.
   endif
   for i := 1 to lenx
      xelement := x[i]
      yelement := y[i]
      if valtype(xelement) <> valtype(yelement)
         return .f.
      else
         if valtype(xelement) == "A"
            if .not. comparearrays(xelement,yelement)
               return .f.
            endif
         else
            if xelement <> yelement
               return .f.
            endif
         endif
      endif
   next i
   return .t.
endif
return nil

function importfromdbf
local cDbfFileName := ""
local aStruct := {}
local aFieldNames := {}
local aFieldTypes := {}
local aWidths := {}
local aData := {}
local aCurRow := {}
local cCurFieldName := ""
local aJustify := {}
local i


cDbfFileName := Getfile ( { {'All DBF Files','*.dbf'} } , 'Open DBF File' , 'c:\' , .f. , .t. )
if len(alltrim(cDbfFileName)) > 0
   select a
   use &cDbfFileName
   aStruct := dbstruct()
   for i := 1 to len(aStruct)
      aadd(aFieldNames,aStruct[i,1])
      aadd(aFieldTypes,aStruct[i,2])
      aadd(aWidths,aStruct[i,3]*10)
      aadd(aJustify,iif(i == 1 .or. aStruct[i,2] == "C" .or. aStruct[i,2] == "D" .or. aStruct[i,2] == "L",0,1))
   next i
   go top
   do while .not. eof()
      for i := 1 to len(aFieldNames)
         cCurFieldName := aFieldNames[i]
         do case
            case aFieldTypes[i] == "C"
               aadd(aCurRow,a->&cCurFieldName)
            case aFieldTypes[i] == "N"                
               aadd(aCurRow,str(a->&cCurFieldName))
            case aFieldTypes[i] == "D"
               aadd(aCurRow,dtoc(a->&cCurFieldName))
            case aFieldTypes[i] == "L"
               aadd(aCurRow,iif(a->&cCurFieldName,"True","False"))
            otherwise
               aadd(aCurRow,a->&cCurFieldName)
         endcase
      next i
      aadd(aData,aclone(aCurRow))
      asize(aCurRow,0)
      select a
      skip
   enddo
   close all
   if iscontroldefined(data,s)
      s.data.release
   endif
   define grid data
      parent s
      row 10
      col 10
      width 1000
      height 600
      items aData
      headers aFieldNames
      widths aWidths
      justify aJustify
   end grid
endif
return nil


function initdata
local aData := {;
               {"EAST", "PRODUCT X","SALESMAN B",3570,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",9148,8 },;               
               {"EAST", "PRODUCT Y","SALESMAN A",2858,25},;
               {"WEST", "PRODUCT X","SALESMAN B",8059,15},;
               {"EAST", "PRODUCT Z","SALESMAN A",2972,24},;
               {"NORTH","PRODUCT X","SALESMAN A",1641,14},;
               {"EAST", "PRODUCT X","SALESMAN A",6046,20},;
               {"WEST", "PRODUCT Y","SALESMAN B",9190,19},;
               {"WEST", "PRODUCT X","SALESMAN A",1411,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",7113,7 },;
               {"SOUTH","PRODUCT X","SALESMAN A",4446,7 },;
               {"NORTH","PRODUCT Y","SALESMAN B",8027,3 },;
               {"EAST", "PRODUCT X","SALESMAN A",6352,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",1234,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",9329,15},;
               {"SOUTH","PRODUCT Y","SALESMAN A",7394,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",2917,12},;
               {"EAST", "PRODUCT Z","SALESMAN B",7373,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9886,23},;
               {"NORTH","PRODUCT X","SALESMAN A",1336,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",2631,22},;
               {"WEST", "PRODUCT X","SALESMAN A",5486,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",9181,23},;
               {"EAST", "PRODUCT X","SALESMAN A",3374,12},;
               {"NORTH","PRODUCT X","SALESMAN B",9281,7 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8644,21},;
               {"SOUTH","PRODUCT X","SALESMAN A",7183,22},;
               {"WEST", "PRODUCT X","SALESMAN B",8544,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",3435,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",2619,18},;
               {"SOUTH","PRODUCT X","SALESMAN B",7648,20},;
               {"EAST", "PRODUCT Y","SALESMAN B",9870,12},;
               {"NORTH","PRODUCT Z","SALESMAN A",6641,9 },;
               {"EAST", "PRODUCT Z","SALESMAN A",6414,19},;
               {"SOUTH","PRODUCT X","SALESMAN A",4137,21},;
               {"EAST", "PRODUCT X","SALESMAN A",5439,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",2828,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",3168,21},;
               {"WEST", "PRODUCT Y","SALESMAN C",3950,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",8722,18},;
               {"NORTH","PRODUCT Z","SALESMAN A",2967,23},;
               {"EAST", "PRODUCT X","SALESMAN A",8312,3 },;
               {"SOUTH","PRODUCT X","SALESMAN C",9258,19},;
               {"EAST", "PRODUCT Y","SALESMAN A",7308,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3497,16},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",8123,17},;
               {"EAST", "PRODUCT Z","SALESMAN A",1594,5 },;
               {"NORTH","PRODUCT X","SALESMAN B",3666,23},;
               {"SOUTH","PRODUCT Y","SALESMAN A",9794,2 },;
               {"WEST", "PRODUCT X","SALESMAN A",7501,2 },;
               {"EAST", "PRODUCT Z","SALESMAN B",9253,24},;
               {"SOUTH","PRODUCT X","SALESMAN A",6492,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2419,8 },;
               {"EAST", "PRODUCT Y","SALESMAN B",8987,25},;
               {"WEST", "PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Z","SALESMAN B",4604,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2820,14},;
               {"NORTH","PRODUCT X","SALESMAN B",6715,20},;
               {"EAST", "PRODUCT Y","SALESMAN A",8272,19},;
               {"SOUTH","PRODUCT X","SALESMAN A",4759,13},;
               {"WEST", "PRODUCT X","SALESMAN B",1678,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",5723,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",7854,3 },;
               {"SOUTH","PRODUCT X","SALESMAN B",3134,14},;
               {"EAST", "PRODUCT Y","SALESMAN B",9375,4 },;
               {"NORTH","PRODUCT Z","SALESMAN A",9622,15},;
               {"EAST", "PRODUCT Z","SALESMAN A",6820,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",5339,12},;
               {"EAST", "PRODUCT X","SALESMAN A",2159,6 },;
               {"WEST", "PRODUCT Y","SALESMAN A",6933,23},;
               {"EAST", "PRODUCT X","SALESMAN A",4318,12},;
               {"WEST", "PRODUCT Y","SALESMAN C",7311,22},;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"NORTH","PRODUCT Z","SALESMAN A",8377,23},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",9200,7 },;
               {"EAST", "PRODUCT Y","SALESMAN A",9993,21},;
               {"WEST", "PRODUCT X","SALESMAN A",3120,22},;
               {"EAST", "PRODUCT X","SALESMAN A",1870,13},;
               {"SOUTH","PRODUCT Z","SALESMAN A",1786,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",1358,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",9190,19},;
               {"WEST", "PRODUCT X","SALESMAN A",1411,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",7113,7 },;
               {"SOUTH","PRODUCT X","SALESMAN A",4446,7 },;
               {"NORTH","PRODUCT Y","SALESMAN B",8027,3 },;
               {"EAST", "PRODUCT X","SALESMAN A",6352,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",1234,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",9329,15},;
               {"SOUTH","PRODUCT Y","SALESMAN A",7394,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",2917,12},;
               {"EAST", "PRODUCT Z","SALESMAN B",7373,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9886,23},;
               {"NORTH","PRODUCT X","SALESMAN A",1336,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",2631,22},;
               {"WEST", "PRODUCT X","SALESMAN A",5486,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",9181,23},;
               {"EAST", "PRODUCT X","SALESMAN A",3374,12},;
               {"NORTH","PRODUCT X","SALESMAN B",9281,7 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8644,21},;
               {"SOUTH","PRODUCT X","SALESMAN A",7183,22},;
               {"WEST", "PRODUCT X","SALESMAN B",8544,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",3435,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",2619,18},;
               {"SOUTH","PRODUCT X","SALESMAN B",7648,20},;
               {"EAST", "PRODUCT Y","SALESMAN B",9870,12},;
               {"NORTH","PRODUCT Z","SALESMAN A",6641,9 },;
               {"EAST", "PRODUCT Z","SALESMAN A",6414,19},;
               {"SOUTH","PRODUCT X","SALESMAN A",4137,21},;
               {"EAST", "PRODUCT X","SALESMAN A",5439,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",2828,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",3168,21},;
               {"WEST", "PRODUCT Y","SALESMAN C",3950,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",8722,18},;
               {"NORTH","PRODUCT Z","SALESMAN A",2967,23},;
               {"EAST", "PRODUCT X","SALESMAN A",8312,3 },;
               {"SOUTH","PRODUCT X","SALESMAN C",9258,19},;
               {"EAST", "PRODUCT Y","SALESMAN A",7308,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3497,16},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 };
            }
return aclone(aData)